import QtQuick 2.9
import MuseScore 3.0
MuseScore {
  menuPath: "Plugins.Toggle solo"  //hacky using .mute, API does not expose .solo yet
  version: "220829"
  onRun:{
    var ps=[]
    var es=curScore.selection.elements
    for (var i = 0; i < es.length; i++){
      var cp=es[i].staff.part //Note Chord Segment, inheriting Element
      if(cp && ps.filter(function _(p){return cp.is(p)}).length==0) ps.push(cp)
    }
    var isEveryUnselectedMuted = true
    var parts = curScore.parts
    for (var i = 0; i < parts.length; i++) {
      var part = parts[i]
      var selected = ( ps.filter(function _(p){return part.is(p)}).length>0 )
      if(!selected){
        var instrs = part.instruments
        for (var j = 0; j < instrs.length; j++) {
            var channels = instrs[j].channels
            for (var k = 0; k < channels.length; k++) {
              if(!channels[k].mute) isEveryUnselectedMuted = false
          }
        }
      }
    }
    //var parts = curScore.parts
    for (var i = 0; i < parts.length; i++) {
      var part = parts[i]
      var selected = ( ps.filter(function _(p){return part.is(p)}).length>0 )
      var instrs = part.instruments
      for (var j = 0; j < instrs.length; j++) {
        var channels = instrs[j].channels
        for (var k = 0; k < channels.length; k++) {
          channels[k].mute = selected? false : !isEveryUnselectedMuted
        }
      }
    }
  }
}